clear
close all

% carr blanc sur fond noir

dim=64; I=zeros(dim,dim);
I(dim/4+1:3*dim/4,dim/4+1:3*dim/4)=1;
whos I

% rosion(I) vs. dilatation(I)

figure(1), colormap('gray')
subplot(1,3,1), imagesc(I), colorbar, axis('square'), title('img orig. I')

disque=strel('disk',10);

IE=imerode(I, disque, 1);
subplot(1,3,2), imagesc(IE), colorbar, axis('square'), title('rosion(I)')

ID=imdilate(I, disque, 1);
subplot(1,3,3), imagesc(ID), colorbar, axis('square'), title('dilatation(I)')

% dilatation(rosion(I)) vs. rosion(dilatation(I))

figure(2), colormap('gray')
subplot(1,3,1), imagesc(I), colorbar, axis('square')
title('img orig. I')

IED=imdilate(IE, disque, 1);
subplot(1,3,2), imagesc(IED), colorbar, axis('square')
title('dilatation(rosion(I))')

IDE=imerode(ID, disque, 1);
subplot(1,3,3), imagesc(IDE), colorbar, axis('square')
title('rosion(dilatation(I))')

{'-----------------------------------' ;
 'comparaison en termes d"intgrale :' ;
 '-----------------------------------' ;
 ['I : ', num2str(sum(sum(I)))] ;
 ['dilatation(rosion(I)) : ', num2str(sum(sum(IED)))] ;
 ['rosion(dilatation(I)) : ', num2str(sum(sum(IDE)))] ;
 '-----------------------------------' }

