clear
close all

trees=imread('/Users/marcel/Documents/MATLAB/0-images-exemples/trees.jpg');
trees=rgb2gray(trees); trees=double(trees)/255.;
whos trees

t_snp=imnoise(trees, 'salt & pepper', 0.05);

figure, colormap(gray)

subplot(2,3,1)
imagesc(trees), colorbar, axis('square'), title('image d"origine')

subplot(2,3,2)
imagesc(t_snp), colorbar, axis('square'), title('image bruite')

carre=strel('square', 2);

tE=imerode(t_snp, carre, 1);

subplot(2,3,3)
imagesc(tE), colorbar, axis('square'), title('rosion...')

tED=imdilate(tE, carre, 1);

subplot(2,3,4)
imagesc(tED), colorbar, axis('square'), title('... puis dilatation...')

tEDD=imdilate(tED, carre, 1);

subplot(2,3,5)
imagesc(tEDD), colorbar, axis('square'), title('... puis re-dilatation...')

tEDDE=imerode(tEDD, carre, 1);

subplot(2,3,6)
imagesc(tEDDE), colorbar, axis('square'), title('... puis re-rosion.')